unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses TypedFiler;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  AStream : TMemorystream;
  Filer : TTypedFiler;
begin
  AStream := TMemorystream.create;
  try
    Filer := TTypedFiler.create(Astream);
    Memo.lines.clear;

    // TS_CARDINAL : TS_CONST_TYPE = $01;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_SMALLINT : TS_CONST_TYPE = $02;
    Memo.lines.add('SmallInt...');
    Filer.GotoStart;
    Filer.WriteSmallInt($FF);
    Filer.GotoStart;
    if Filer.readSmallInt <> $FF then memo.lines.add('   -   Failed');

    // TS_STRING : TS_CONST_TYPE = $03;
    Memo.lines.add('String...');
    Filer.GotoStart;
    Filer.writeString('My String');
    Filer.GotoStart;
    if Filer.ReadString <> 'My String' then memo.lines.add('   -   Failed');

    // TS_COLOR : TS_CONST_TYPE = $04;
    Memo.lines.add('Color...');
    Filer.GotoStart;
    Filer.WriteColor(ClBlack);
    Filer.GotoStart;
    if Filer.ReadColor <> ClBlack then memo.lines.add('   -   Failed');

    // TS_GUID : TS_CONST_TYPE = $05;
    Memo.lines.add('GUID...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_WIDESTRING : TS_CONST_TYPE = $06;
    Memo.lines.add('WIDETRING...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_BOOLEAN : TS_CONST_TYPE = $07;
    Memo.lines.add('Boolean...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_FLOAT    : TS_CONST_TYPE = $08;
    Memo.lines.add('Float...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_SINGLE : TS_CONST_TYPE = $09;
    Memo.lines.add('Single...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_CURRENCY : TS_CONST_TYPE = $0A;
    Memo.lines.add('Currency...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_DATETIME : TS_CONST_TYPE = $0B;
    Memo.lines.add('DateTime...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_VARIANT : TS_CONST_TYPE = $0C;
    Memo.lines.add('Variant...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_WORD : TS_CONST_TYPE = $0D;
    Memo.lines.add('Word...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_INTEGER : TS_CONST_TYPE = $0E;
    Memo.lines.add('Integer...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_EXCEPTION : TS_CONST_TYPE = $0F;
    Memo.lines.add('Exception...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_STREAM : TS_CONST_TYPE = $10;
    Memo.lines.add('Stream...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_INT64 : TS_CONST_TYPE = $11;
    Memo.lines.add('Int64...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_IPADDRESS : TS_CONST_TYPE = $12;
    Memo.lines.add('IP Address...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_VERSION : TS_CONST_TYPE = $13;
    Memo.lines.add('Version...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_ENCRYPTEDSTREAM : TS_CONST_TYPE = $14;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_VARTYPE : TS_CONST_TYPE = $15;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_SHORTINT : TS_CONST_TYPE = $16;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_BYTE : TS_CONST_TYPE = $17;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_FONT : TS_CONST_TYPE = $18;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_PICTURE : TS_CONST_TYPE = $19;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');

    // TS_COMPRESSEDSTREAM : TS_CONST_TYPE  = $1A;
    Memo.lines.add('Cardinal...');
    Filer.GotoStart;
    Filer.WriteCardinal($FFFFFFFF);
    Filer.GotoStart;
    if Filer.readCardinal <> $FFFFFFFF then memo.lines.add('   -   Failed');
  finally
    AStream.Free;
  end;
end;

end.
